<template>
  <div>
    <div
      class="details-container container"
      :class="isLoading || error ? 'hide' : 'show'"
    >
      <h2>Details</h2>
      <div id="evaluation-overview">
        <table class="evaluation-table">
          <tr>
            <td id="step0" class="evaluation-step">
              Step 1: <br />Access Request is submitted
            </td>
            <td id="step1" class="evaluation-step">
              Step 2: <br />Dataset Access Manager(s) evaluation
            </td>
            <td id="step2" class="evaluation-step">
              Step 3: <br />Project Coordinator evaluation
            </td>
          </tr>
        </table>
      </div>
    </div>
    <div v-if="!error" id="container">
      <Loading v-if="isLoading" />
      <div v-if="!isLoading">
        <AccessRequestDetailsVue
          v-if="accessRequest"
          :access-request="accessRequest"
        />
        <div v-if="showEvaluationButton" class="container">
          <a :href="`/access-request/${accessRequest.id}/evaluation`">
            <b-button>Evaluate</b-button>
          </a>
        </div>
        <hr />
        <AccessRequestEvaluationDetailsVue
          v-if="accessRequest"
          :access-request="accessRequest"
        />
      </div>
    </div>
    <div v-if="error && !isLoading" class="error">
      <Error :error="error" />
    </div>
  </div>
</template>

<script>
import AccessRequestEvaluationDetailsVue from '~/components/AccessRequestEvaluationDetails.vue';
import AccessRequestDetailsVue from '~/components/AccessRequestDetails.vue';
import Loading from '~/components/Loading.vue';
import Error from '~/layouts/error.vue';

export default {
  components: {
    Error,
    AccessRequestEvaluationDetailsVue,
    AccessRequestDetailsVue,
    Loading,
  },
  layout: 'dashboard',
  middleware: 'auth',
  data() {
    return {
      accessRequest: null,
      isLoading: true,
      error: false,
      showEvaluationButton: true,
      roles: [],
    };
  },
  async fetch() {
    try {
      this.accessRequest = await this.$nuxt.context.store.dispatch(
        'access_request/fetchAccessRequest',
        this.$nuxt.$route.params.id
      );
      function parseJwt(token) {
        return JSON.parse(
          Buffer.from(token.split('.')[1], 'base64').toString()
        );
      }
      const token = this.$auth.strategy.token.get().split(' ');
      const parsedToken = parseJwt(token[1]);
      const userEmail = parsedToken.email;
      this.roles = parsedToken.realm_access.roles;

      const ar = this.accessRequest;
      if (ar.step === 0) {
        this.showEvaluationButton = false;
      }

      if (ar.status !== 'Pending') {
        this.showEvaluationButton = false;
      }

      if (ar.step === 2 && !this.hasRole('PC')) {
        this.showEvaluationButton = false;
      }

      if (ar.step === 1 && !ar.decision_am) {
        if (
          !ar.datasets
            .find((d) => d.is_main === 1)
            .dataset.access_managers.map((a) => a.user_email.toLowerCase())
            .includes(userEmail.toLowerCase())
        ) {
          this.showEvaluationButton = false;
        }
      }

      if (ar.step === 1 && ar.decision_am) {
        const secondaryDatasets = ar.datasets.filter((d) => {
          return (
            d.is_main === 0 &&
            d.decision == null &&
            d.is_cancelled === 0 &&
            d.dataset.access_managers
              .map((a) => a.user_email.toLowerCase())
              .includes(userEmail.toLowerCase())
          );
        });
        if (secondaryDatasets.length === 0) {
          this.showEvaluationButton = false;
        }
      }
    } catch (e) {
      this.error = { statusCode: 404 };
    }
  },
  head() {
    return { title: 'Access Request Details - RCF' };
  },
  mounted() {
    const e = this.accessRequest;
    function gebi(step) {
      return document.getElementById(`step${step}`);
    }
    this.isLoading = false;

    if (e.is_submitted === 1) {
      gebi(0).classList.add('green');
    }

    if (e.cancelled === 1) {
      gebi(1).classList.add('red');
      const dateString = new Date(e.updated_at).toLocaleString('en-UK', {
        dateStyle: 'medium',
      });
      gebi(1).innerHTML += ` (cancelled by applicant on ${dateString})`;
      return;
    }

    if (e.decision_am === 'Positive') {
      if (!e.datasets.find((dataset) => dataset.decision == null)) {
        gebi(1).classList.add('green');
        gebi(1).innerHTML += ' (evaluated positively)';
      }
    } else if (e.decision_am === 'Negative') {
      gebi(1).classList.add('red');
      gebi(1).innerHTML += ' (evaluated negatively)';
      return;
    } else if (e.decision_am === 'Revise') {
      gebi(1).classList.add('yellow');
      gebi(1).innerHTML += ' (awaiting revision from applicant)';
      return;
    }

    if (e.decision_pc === 'Positive') {
      gebi(2).classList.add('green');
      gebi(2).innerHTML += ' (evaluated positively)';
    } else if (e.decision_pc === 'Negative') {
      gebi(2).classList.add('red');
      gebi(2).innerHTML += ' (evaluated negatively)';
      return;
    }

    if (e.step < 3) {
      gebi(e.step).classList.add('orange');
      if (e.cancelled === 1) {
        gebi(e.step).classList.add('red');
        gebi(e.step).classList.remove('orange');
        gebi(e.step).classList.remove('yellow');
        gebi(e.step).innerHTML += ' (cancelled by user)';
      }
    }
  },
  methods: {
    hasRole(role) {
      return this.roles && this.roles.includes(role);
    },
  },
};
</script>

<style scoped>
table tr td {
  vertical-align: top;
  padding: 5px;
}

.container {
  margin-bottom: 20px;
}

.evaluation-step {
  color: white;
  background-color: lightgray;
  border: 1px solid lightgray;
  padding: 10px 10px 10px 10px;
  font-weight: bold;
}

.evaluation-table {
  width: 100%;
}

#evaluation-overview {
  margin-bottom: 20px;
}

.evaluation-table td {
  width: 25%;
}

.show {
  opacity: 100;
}

.hide {
  opacity: 0;
}

.green {
  background-color: #60b560;
}

.red {
  background-color: #ff6363;
}

.orange {
  background-color: #ffb06a;
}

.yellow {
  background-color: #f3de20;
  color: black;
}
</style>
